/*
 * Created on 30/03/2004
 */
 
package edg6.ed;
import ine5384.ListaEncadeada;
import ine5384.dp.Visitante;
import ine5384.excecao.ExcecaoDadoNulo;
import ine5384.excecao.ExcecaoEstruturaVazia;
import ine5384.excecao.ExcecaoOperacaoIlegal;

/**
 * @author PedroH
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class ListaRecursiva implements ListaEncadeada
{
   protected Object dado;
   protected ListaEncadeada resto;
  
   /**
    * Construtor
    *
    */
   public ListaRecursiva()
   {
      this.dado = null;
      this.resto = null;	 
   }
   
   /**
    * Construtor
    * @param dado
    * @param resto
    */
   public ListaRecursiva(Object dado,ListaEncadeada resto)
   {
   	  this.dado = dado;
   	  this.resto = resto;
   }
   
   public Object getDado()
   {
   	  return this.dado;
   }
   
   public ListaEncadeada getResto()
   {
   	  return this.resto;
   }
   
   public void setDado(Object dado)
   {
   	  this.dado = dado;
   }
   
   public void setResto(ListaEncadeada resto)
   {
      this.resto = resto;	
   }
      
   /**
    * estaVazia    
    */
   public boolean estaVazia()
   {
      if(this.dado == null)
         return true;
      return false;
   }
   
   
   /**
    * estaCheia
    */
   public boolean estaCheia()
   {
   	  // TODO      
      return false;
   }
   
   /**
    *  retorneTamanho 
    */
   public int retorneTamanho()
   {
      if(estaVazia())
         return 0;
      else
         return resto.retorneTamanho()+1;
   }
   
   /**
    * 
    */
   public void insiraNoInicio(Object novoDado) throws ExcecaoDadoNulo
   {
      ListaRecursiva aux = new ListaRecursiva(this.dado,this.resto);
      this.dado = novoDado;
      this.resto = aux;      
   }
   
   /**
    * 
    */
   public void insiraNoFinal(Object novoDado) throws ExcecaoDadoNulo
   {
      if(estaVazia())
         insiraNoInicio(novoDado);
      else
         resto.insiraNoFinal(novoDado);
   }
   
   /**
    * 
    */
   public void insiraNaPos(Object novoDado, int pos) throws ExcecaoDadoNulo, ExcecaoOperacaoIlegal
   {
      if(novoDado == null)
         throw new ExcecaoDadoNulo(novoDado);
         
      if(pos == 1)
         insiraNoInicio(novoDado);
      else
         if(estaVazia())
            throw new ExcecaoOperacaoIlegal(novoDado);
         else
            resto.insiraNaPos(novoDado,pos -1);         	         
   }
   
   /**
    * 
    */
   public Object retorneDoInicio() throws ExcecaoEstruturaVazia
   {
      if(!estaVazia())
         return this.dado;
      else
         throw new ExcecaoEstruturaVazia(null);
   }
   
   /**
    * 
    */
   public Object retorneDoFinal() throws ExcecaoEstruturaVazia
   {
      if(estaVazia())
         throw new ExcecaoEstruturaVazia(null);
      else
         if(resto.estaVazia())
            return this.dado;
         else
            return resto.retorneDoFinal();
   }

   /**
    * 
    */
   public Object retorneDaPos(int pos) throws ExcecaoEstruturaVazia, ExcecaoOperacaoIlegal
   {
      if(estaVazia())
         throw new ExcecaoEstruturaVazia(null);
      else
      {        	       
         if(pos == 1)
            return this.dado;
         else
         {
            if(resto.estaVazia())
               throw new ExcecaoOperacaoIlegal(null);       
            return resto.retorneDaPos(pos - 1);
         }
      }   
   }
   
   /**
    * 
    */
   public Object removaDoInicio() throws ExcecaoEstruturaVazia
   {
      if(estaVazia())
         throw new ExcecaoEstruturaVazia(null);
      else 
      {
      	 Object result = this.dado;
         this.dado = resto.retorneDoInicio();                  
         this.resto = ((ListaRecursiva)resto).getResto();
         return result;                
      }
   }
   
   /**
    * 
    */
   public Object removaDoFinal() throws ExcecaoEstruturaVazia
   {
      if(estaVazia())
         throw new ExcecaoEstruturaVazia(null);
      else
         if(resto.estaVazia())
         {
         	Object result = this.dado;
            this.dado = null;
            this.resto = null;
            return result;
         }else
            return resto.removaDoFinal();      
   }
      
   /**
    * 
    */   
   public Object removaDaPos(int pos) throws ExcecaoEstruturaVazia, ExcecaoOperacaoIlegal
   {
		if(estaVazia())
			throw new ExcecaoEstruturaVazia(null);
		else
		{        	       
			if(pos == 1)
			{
               			      
			   return this.dado;
			}
			else
			{
				if(resto.estaVazia())
					throw new ExcecaoOperacaoIlegal(null);       
				return resto.retorneDaPos(pos - 1);
			}
		}    	
   }
   
   /**
    * 
    */
   public void substituaNoInicio(Object novoDado) throws ExcecaoDadoNulo, ExcecaoEstruturaVazia
   {
      if(novoDado == null)
         throw new ExcecaoDadoNulo(null);
         
      if(estaVazia())
         throw new ExcecaoEstruturaVazia(null);
      else
         this.dado = novoDado;            
   }
   
   /**
    * 
    */
   public void substituaNoFinal(Object novoDado) throws ExcecaoDadoNulo, ExcecaoEstruturaVazia
   {
      if(novoDado == null)
         throw new ExcecaoDadoNulo(null);
      
      if(estaVazia())
         throw new ExcecaoEstruturaVazia(null);
      else
         if(resto.estaVazia())
            this.dado = novoDado;
         else
            resto.substituaNoFinal(novoDado);        
   }
   
   /**
    * 
    */
   public void substituaNaPos(Object novoDado, int pos) throws ExcecaoDadoNulo, ExcecaoEstruturaVazia, ExcecaoOperacaoIlegal
   {

		if(novoDado == null)
			throw new ExcecaoDadoNulo(null);		
		
		if(estaVazia())
			throw new ExcecaoEstruturaVazia(null);
		else
		{        	       
			if(pos == 1)
			{               			      
				this.dado = novoDado;
			}
			else
			{
				if(resto.estaVazia())
					throw new ExcecaoOperacaoIlegal(null);       
				resto.substituaNaPos(novoDado,pos - 1);
			}
		}   


   }
   
   
   /**
    * 
    */
   public boolean pertence(Object dado) throws ExcecaoDadoNulo
   {      
   	if(dado == null)
   	   throw new ExcecaoDadoNulo(null);
   	
   	if(estaVazia())
   	   return false;   	
   	else
   	   if(this.dado == dado)
   	      return true;
   	   else
   	      return this.resto.pertence(dado);
   	    
   }
   
   /**
    * 
    */
   public boolean temIgual(Object arg0) throws ExcecaoDadoNulo
   {
		if(dado == null)
			throw new ExcecaoDadoNulo(null);
   	
		if(estaVazia())
			return false;   	
		else
			if(this.dado.equals(dado))
				return true;
			else
				return this.resto.pertence(dado);
   }
   /* (non-Javadoc)
    * @see ine5384.ListaEncadeada#recebaVisitante(ine5384.dp.Visitante)
    */
   public void recebaVisitante(Visitante arg0)
   {
      // TODO 
   }
}
