/*
 * Created on 03/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edg6.tf.dp;

import java.io.RandomAccessFile;
import java.io.FileNotFoundException;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.io.IOException;

public class Arquivo
{
	private RandomAccessFile raf;
	private String caminho;
	private ByteBuffer bb;
	private FileChannel fc;
	private boolean aberto;
		
   public Arquivo(String caminho) throws FileNotFoundException,IOException
   {
      this.caminho = caminho;
      abreArquivo();
      fechaArquivo();     
      aberto = false;
   }  
   
   public String getCaminho()
   {
   	if(caminho != null){
   	   return this.caminho;
   	}
   	return "";
   }   

   public void write(Object objectToWrite,long pos,boolean deixaAberto) throws IOException
   {
   	if(! aberto)
   	   abreArquivo();
	   byte[] bytesToWrite = objectToWrite.toString().getBytes("ISO-8859-1");	   
	   fc.position(pos);	   
		fc.write(ByteBuffer.wrap(bytesToWrite));
		if(!deixaAberto)
		   fechaArquivo();		
   }

	public void write(byte[] bytesToWrite,long pos,boolean deixaAberto) throws IOException
	{
		if(! aberto)
			abreArquivo();		   
		fc.position(pos);	   
		fc.write(ByteBuffer.wrap(bytesToWrite));
		if(!deixaAberto)
			fechaArquivo();		
	}   
   
   public byte[] read(long pos,int qtosBytes,boolean deixaAberto) throws IOException
   {
   	if(! aberto)
   	   abreArquivo();
   	fc.position(pos);
   	bb = ByteBuffer.allocate(qtosBytes);
   	fc.read(bb);
   	if(!deixaAberto)
   	   fechaArquivo();
   	return bb.array();
   }       
   
   public long tamanho(boolean deixaAberto) throws IOException
   {
   	if(!aberto)
		   abreArquivo();
   	long result = fc.size();
   	if(!deixaAberto)
		  fechaArquivo();
   	return result; 
		   	    
   }
   
   public void abreArquivo() throws FileNotFoundException
   {
   	if(!aberto)
   	{
   	   raf = new RandomAccessFile(caminho,"rw"); 
		   fc = raf.getChannel();          	   			
		   aberto = true;
		   System.out.println("=======ABRIU=========");
   	}
   }   
   
   public void fechaArquivo() throws IOException
   {
   	if(aberto)
   	{    
         raf.close();
         aberto = false;
		   System.out.println("=======FECHOU=========");
   	}
   }
   
   public void resize(long size) throws IOException
   {   	      
      abreArquivo();   	
   	raf.setLength(size);
   	fechaArquivo();
   }   
   
}
