/*
 * Created on 03/04/2004
 *
 */
package edg6.tf.dp;

import java.io.UnsupportedEncodingException;

public class Registro
{
	public static int regSize = 50; 
		
	private String placa;
	private String proprietario;
	private String situacao;
	private char documentacao;
	private char pagamento;
	private String acionado;
	
	public Registro()
	{
		placa = new String();
		proprietario = new String();
		situacao = new String();
		documentacao = ' ';
		pagamento = ' ';
		acionado = new String();
	}
	
	public Registro setPlaca(String placa)
	{
		this.placa = placa;
		return this;
	}
	
	public Registro setProprietario(String proprietario)
	{
		this.proprietario = proprietario;
		return this;
	}	
	
	public Registro setSituacao(String situacao)
	{
		this.situacao = situacao;
		return this;
	}

	public Registro setDocumentacao(char documentacao)
	{
		this.documentacao = documentacao;
		return this;
	}

	public Registro setPagamento(char pagamento)
	{
		this.pagamento = pagamento;
		return this;
	}	
	
	public Registro setAcionado(String acionado)
	{
		this.acionado = acionado;
		return this;
	}	

	public String getPlaca()
	{
		return this.placa;	
	}

	public String getProprietario()
	{
		return this.proprietario;	
	}
	
	public String getSituacao()
	{
		return this.situacao;	
	}
			
	public char getDocumentacao()
	{
		return this.documentacao;
	}
	
	public char getPagamento()
	{
		return this.pagamento;		
	}
	
	public String getAcionado()
	{
		return this.acionado;
	}	
	
	public String getTextoSituacao()
	{
		String  result;
		if(situacao.equals("00"))
		   result = "OK";
		else if (situacao.equals("01"))
		   result = "Roubado";
		else if (situacao.equals("02"))
		   result = "No Seguro";
		else
		   result = "Cdigo Invlido: " + situacao;
		return result; 
	}
	
	public String getTextoDocumentacao()
	{
		String result;
		if (documentacao=='0')
		   result = "OK";
		else if (documentacao=='1')
		   result = "Irregular";
		else
		   result = "Cdigo Invlido: " + documentacao;
		return result;
	}
	
	public String getTextoPagamento()
	{
		String result;
		if (pagamento=='0')
			result = "OK";
		else if (pagamento=='1')
			result = "Irregular";
		else
			result = "Cdigo Invlido: " + pagamento;
		return result;
	}
	
	public String toString()
	{		
		return padroniza(placa,7) + ' ' +
		       padroniza(proprietario,30) + ' '+
		       padroniza(situacao,2) + ' '+
		       documentacao + ' '+
		       pagamento + ' '+
		       padroniza(acionado,3)+'\n';
		       
	}
	
	private String padroniza(String str,int tamanho)
	{
		while(str.length() < tamanho)
		   str += " ";
		
		if(str.length() > tamanho)
		   str = str.substring(0,tamanho);
		
		return str;
	}
	
	public static Registro parse(byte[] reg) throws ExcecaoParseRegistro
	{
		if(reg.length < Registro.regSize)
		   throw new ExcecaoParseRegistro("Byte[] tem menos de 50 posicoes, nao da pra converter");		   
				
		Registro result = new Registro();
		
		try{
		   result.placa = byteArrayToString(reg,0,7);			   
			result.proprietario = byteArrayToString(reg,8,38);
			result.situacao = byteArrayToString(reg,39,41);
			result.documentacao = byteArrayToString(reg,42,43).charAt(0);
			result.pagamento = byteArrayToString(reg,44,45).charAt(0);
			result.acionado = byteArrayToString(reg,46,49);						
			
		}catch(Exception ex)
		{
			throw new ExcecaoParseRegistro("No foi possivel fazer a conversao do vetor de bytes para um Registro");					
		}
		return result;		
	}
	
	
	private static String byteArrayToString(byte[] b,int posInicio,int posFinal) throws UnsupportedEncodingException
	{
		byte[] result = new byte[posFinal-posInicio];
		for(int i=posInicio;i<posFinal;i++)
		{
			result[i-posInicio] = b[i];
		}
		return new String(result,"iso-8859-1");
	}
	
	

}
