/*
 * Created on 03/04/2004
 *
 */
package edg6.tf.dp;

import edg6.tf.igu.InterfaceUsuario2;
import java.io.IOException;

public class SistemaSeguradora
{
	private Arquivo arquivo;
	private InterfaceUsuario2 interf;
		
	
	public void inicia()
	{
		interf = new InterfaceUsuario2(this);		
		interf.inicia();
	}
	
	public boolean definiuArquivo(){
		if(this.arquivo != null) 
		   return true;
		return false;
	}
	
	public String getCaminhoArquivo(){
		if(arquivo != null)
         return arquivo.getCaminho();
      return("No especificado");  
	}
	
	public boolean abriuArquivo(){
		if(arquivo != null)
		   return true;
		return false;
	}
		
	/**
	 * DEFINA ARQUIVO 
	 * @param caminho
	 */
	public void definaArquivo(String caminho) 
	{
		try{		
		   this.arquivo = new Arquivo(caminho);
		}catch(IOException ex)
		{
			interf.escreveErro("Caminho invlido",true);				
		}		
	}
	
	/**
	 * INCLUA DADOS 
	 * @param registro
	 */
	public boolean incluaDados(Registro registro,boolean deixaArqAberto)
	{
		boolean result = false;
		try{
			arquivo.abreArquivo();		
		   if(arquivo != null)		   		  
		   {
		   	if(posicaoPlaca(registro.getPlaca(),true) == -1)
		   	{		   			   	
               arquivo.write(registro,arquivo.tamanho(true),true);
               result = true;
					interf.escreveErro("Incluido com sucesso",false);  
		   	}
            else
            {                           
               interf.escreveErro("J existe veculo cadastrado com essa placa",true);           
            }            
                  
		   }else
		   {
   			interf.escreveErro("Arquivo no definido",true);				
	   	}
	   	if(!deixaArqAberto)
	   	{
	   		arquivo.fechaArquivo();	   			  
	   	}
		}catch(IOException e)
		{
			interf.escreveErro("Erro Ao Inserir",true);
		}
		return result;
		
	}
	
	/**
	 * ALTERA DADOS 
	 * @param atual
	 * @param novo
	 */
	public void alteraDados(String placa)
	{  
		try{
		
		   arquivo.abreArquivo();
		   int pos = posicaoPlaca(placa,true);		   
		   if(pos > -1)
		   {
		      procuraPorPosicao(pos); 
            Registro novoDado;
		      novoDado = interf.pegaDadosRegistro();
		      if(!placa.equals(novoDado.getPlaca()))
		      {	
		      	int pos2 = posicaoPlaca(novoDado.getPlaca(),true);
		      	if(pos2 != -1)
		      	{ 
		      		interf.escreveErro("Nova placa j existe",false);
		      	}else
		      	{		      	
		      	   arquivo.write(novoDado,(pos)*Registro.regSize,false);		      	   
		      	   interf.escreveErro("Alterado com sucesso",false);		      	   
		      	}
		      }
		      else
		      {
		      	arquivo.write(novoDado,(pos)*Registro.regSize,false);
					interf.escreveErro("Alterado com sucesso",false);
		      }		         		         		     		      
		   }else
		   {
            interf.escreveErro("No existe veculo com esta placa.",true);
		   }
		   arquivo.fechaArquivo();
		}catch(IOException ex)
		{
			interf.escreveErro("Erro ao pesquisar placa",true);
		}
 
	}
	
	/**
	 * REMOVA DADOS 
	 * @param registro
	 */
	public void removaDados(String placa)
	{
		try{		
			arquivo.abreArquivo();
			int pos = posicaoPlaca(placa,true);			
			if(pos > -1)
			{
				//Se o registro a ser excluido for o ltimo exclui direto
				if(arquivo.tamanho(true)-Registro.regSize != pos*Registro.regSize)				
				{				
		         byte[] b = arquivo.read(arquivo.tamanho(true)-Registro.regSize,Registro.regSize,true);
		         arquivo.write(b,pos*Registro.regSize,true);
				}   
		      arquivo.resize(arquivo.tamanho(true)-Registro.regSize);		         		         		     		      
			}else
			{
				interf.escreveErro("No existe veculo com esta placa.",true);
			}
			arquivo.fechaArquivo();
		}catch(IOException ex)
		{
			interf.escreveErro("Erro ao deleter registro",true);
		}		
		
	}
	
	/**
	 * INCLUA DADOS ALEATORIOS 
	 * @param quantidade
	 */
	public void incluaDadosAleatorios(int quantidade)
	{
		interf.escreveMensagem("-----------------------------------------------------------");
		interf.escreveMensagem("|  Incluir Dados Aleatrios: "+quantidade+"registros");
		interf.escreveMensagem("|");
		int cont = 0;
		while(cont < quantidade)
		{
			Registro reg = new Registro();			
			
			reg.setPlaca(GeradorAleatorio.geraPlaca());
			reg.setProprietario(GeradorAleatorio.geraNome());
			reg.setAcionado(GeradorAleatorio.geraNumVezesAcionouSeguro());
			reg.setDocumentacao(GeradorAleatorio.geraCharBin());
			reg.setPagamento(GeradorAleatorio.geraCharBin());
			reg.setSituacao(GeradorAleatorio.geraSituacao());
						
			
			if(incluaDados(reg,true))
			   cont++;
			
			interf.escreveMensagem("| "+cont+" de "+quantidade);
		}
		try{		
		   arquivo.fechaArquivo();
		}catch(IOException e)
		{
			interf.escreveErro("Erro ao fechar o arquivo",true);
		}
		
	}
	
	/**
	 * PROCURA POR PLACA 
	 * @param placa
	 */
	public void procuraPorPlaca(String placa)
	{
		try{
			arquivo.abreArquivo();
			int pos = posicaoPlaca(placa,true);
			System.out.println(pos);
		   if(pos != -1)
		   {
		   	interf.mostraDadosRegistro(Registro.parse(arquivo.read((pos)*Registro.regSize,
				                                            Registro.regSize,false))); 
		   }
		   else
		   {
		   	interf.escreveErro("Placa no cadastrada no sistema",true);
		   }
		   arquivo.fechaArquivo();
		}catch(IOException e)
		{
			interf.escreveErro("Erro ao procurar por placa",true);
		}catch(ExcecaoParseRegistro e)
		{
			interf.escreveErro("Erro ao parsear o Registro lido do arquivo",true);
		}
	}
	
	/**
	 * PROCURA POR POSICAO
	 * @param posicao
	 */
	public void procuraPorPosicao(int posicao)
	{
		try{		
			if(arquivo != null)		   		  
			{
				if((posicao > 0) && (posicao <= arquivo.tamanho(true)/Registro.regSize))
				{				
					interf.mostraDadosRegistro(Registro.parse(arquivo.read((posicao-1)*Registro.regSize,
					                                                        Registro.regSize,false)));
				}
				else
				{
					interf.escreveErro("Posicao no existe no arquivo",true);
				}
			}else
			{
				interf.escreveErro("Arquivo no definido",true);				
			}
			arquivo.fechaArquivo();
		}catch(IOException e)
		{
			interf.escreveErro("Erro Consultar",true);
		}catch(ExcecaoParseRegistro e)
		{
			interf.escreveErro("Erro aoconverter os dados para um Registro",true);
		}
	}
	
	/**
	 * MOSTRA NUM REGISTROS 
	 *
	 */
	public void mostraNumRegistros()
	{
		if(arquivo != null)	
         try{
            interf.escreveErro("N de Registros: "+(int)(arquivo.tamanho(false)/Registro.regSize),true);	
         
         }catch(Exception ex)
		   {
   			interf.escreveErro("Erro ao obter numero de registros",true);
   			ex.printStackTrace();
	   	}
		else{
			
		}
		
	}
	
	/**
	 * POSICAO PLACA 
	 * @param placa
	 * @return
	 */
	public int posicaoPlaca(String placa,boolean deixaAberto) throws IOException
	{
		long posArqAtual=0;
		int posicaoPlaca = -1;
		long tam = arquivo.tamanho(deixaAberto);
		String placaLida;
		while((posArqAtual < tam )&& (posicaoPlaca < 0))
		{
			byte[] bytePlaca = arquivo.read(posArqAtual,7,true);
			placaLida = new String(bytePlaca,"iso-8859-1");
			
			if(placaLida.equals(placa))
			{
				posicaoPlaca = (int)posArqAtual/Registro.regSize;
				break;
			}
			
			posArqAtual += Registro.regSize;
		}
		
		return posicaoPlaca;
	}
	
	

}
