/*
 * Created on 30/03/2004
 *
 */
package edg6.tf.igu;

import java.io.IOException;
import edg6.tf.dp.SistemaSeguradora;
import edg6.tf.dp.Registro;
/**
 * @author aluno
 *
 */
public class InterfaceUsuario {
	
	protected SistemaSeguradora sis;
	
	public InterfaceUsuario(SistemaSeguradora sis)
	{
		this.sis = sis;
	}

   public void desenhaMenuPrincipal()
   {
   	  System.out.println("##############################################################");
   	  System.out.println("#   TRABALHO DE ESTRUTURA DE DADOS - GRUPO 06 - Versao 1.0a  #");
   	  System.out.println("##############################################################");   	  
   	  System.out.println("");
   	  //if(sis.definiuArquivo())
   	  //{
   	  	  System.out.print(" Arquivo Atual: ");
   	  	  System.out.println(sis.getCaminhoArquivo());
   	  	  System.out.println("");
   	  //1}
   	  
   	  System.out.println("   1 - Definir arquivo de dados");
   	  System.out.println("   2 - Incluir dados");
	     System.out.println("   3 - Alterar dados");
	     System.out.println("   4 - Remover dados");
	     System.out.println("   5 - Incluir dados aleatorios");
	     System.out.println("   6 - Procurar por placa");
	     System.out.println("   7 - Procurar por posicao no arquivo");    
	     System.out.println("   8 - Mostrar numero total de registros");
	     System.out.println("");
	     System.out.println("   x - Sair do programa");
	     System.out.println("");
	     System.out.println("");
   } 
		
	
   public void inicia()
   {  
	  char escolha = ' ';
	  
	  while(escolha != 'x')   	  
      {      	 
      	 desenhaMenuPrincipal();
      	 escolha = leTecla("  Opcao: ");
      	 
      	 executaOpcao(escolha);
      	           	       	   	       	       	       	 	
      }
      System.out.println("");
      System.out.println("#############################################");
      System.out.println("# Obrigado por usar nosso sistema!!!!! :-)  #");
	   System.out.println("#############################################");
      
   }
   
   public void executaOpcao(char escolha)
   {
   	if(escolha == '1'){   		
   		sis.definaArquivo(pegaCaminhoArquivo());
   	}else if(!sis.abriuArquivo()){
   		escreveErro("No existe arquivo definido",true);
   	}else if(escolha == '2')
   	{
         sis.incluaDados(pegaDadosRegistro(),false);
   	}else if(escolha=='3')
   	{
   		sis.alteraDados(pegaPlaca());
   	}else if(escolha == '4')
   	{
   		sis.removaDados(pegaPlaca());
   	}else if(escolha=='5')
   	{
   		sis.incluaDadosAleatorios(pegaNumInt(" Digite a quantidade de dados aleatorios: "));
   	}else if(escolha=='6')
   	{
   		sis.procuraPorPlaca(pegaPlaca());
   	}else if(escolha=='7')
   	{
   		sis.procuraPorPosicao(pegaNumInt(" Digite a posicao no registro: "));
   	}else if(escolha=='8')
   	{
   		sis.mostraNumRegistros();
   	}
   	
    
   }
   
   /**
    * PEGA CAMINHO ARQUIVO
    * @return
    */
   public String pegaCaminhoArquivo()
   {   	
      return leString(" Digite o caminho do arquivo: ");	   
   }
   
   /**
    * PEGA DADOS REGISTRO
    * @return
    */
   public Registro pegaDadosRegistro()
   {
   	Registro result = new Registro();
   	
   	System.out.println("Digite os dados: ");
   	
   	result.setPlaca(leString("  Placa: ",7));
   	result.setProprietario(leString("  Proprietario: ",30));
   	result.setSituacao(leString("  Situacao: 01-OK  02-roubado  03-seguro : ",2));
   	result.setDocumentacao(leTecla("  Documentacao: 0-OK  1-irregular : "));
   	result.setPagamento(leTecla("  Pagamento: 0-OK  1-irregular : "));
   	result.setAcionado(leString("  N de vezes q acionou o seguro: ",3));
   	
   	//System.out.println(result.toString());   	   	
   	
   	return result;
   }
   
   public void mostraDadosRegistro(Registro registro)
   {
		System.out.println(" ----------------------- DADOS DO REGISTRO ------------------------------");
   	System.out.println("| Placa: " + registro.getPlaca());
		System.out.println("| Proprietario: " + registro.getProprietario());
		System.out.println("| Situacao: " + registro.getTextoSituacao());
		System.out.println("| Documentacao: " + registro.getTextoDocumentacao());
		System.out.println("| Pagamento: " + registro.getTextoPagamento());
		System.out.println("| N vezes que seguro foi acionado: " + registro.getAcionado());
		System.out.println(" -------------------------------------------------------------------------");
		leTecla("Pressione ENTER para continuar");
   }
   
   /**
    * PEGA PLACA
    * @return
    */
   public String pegaPlaca()
   {
   	return leString(" Digite placa do registro a ser alterado: ",7);
   }
   
	
	/**
	 * PEGA NUM INT
	 * @return
	 */
	public int pegaNumInt(String mensagem)
	{
		int qtd;
		try
		{
		   qtd = Integer.parseInt(leString(mensagem));
		} 
		catch (NumberFormatException ex){
			qtd = 0;
		}
		return qtd;
	}
	

	
	/**
	 * LE TECLA
	 * @param textoAntes
	 * @return
	 */
   public char leTecla(String textoAntes)
   {  
   	  int result = -1;
   	  try{
   	  	 System.out.print(textoAntes); 	  
         result = System.in.read();                          
         for(int i = System.in.available();i > 0 ;i--)
         {         
            System.in.read();
         }
                  
   	  }catch(IOException ex){}
   	  return (char)result;
   }
   
   /**
    * LE STRING
    * @param textoAntes
    * @return
    */
	public String leString(String textoAntes)
	{  
      StringBuffer result = new StringBuffer();
      
		try{
         System.out.print(textoAntes);
         
         char tecla = (char)System.in.read();
         while(tecla != 13)
         { 	  
         	result.append(tecla);
         	tecla = (char)System.in.read();
         }                                                     
         for(int i = System.in.available();i > 0 ;i--)
			{         
				System.in.read();
			}
                  
      }catch(IOException ex)
      {}
      return result.toString();
	}  
	 


   /**
    * LE STRING
    * @param textoAntes
    * @param maxTam
    * @return
    */
	public String leString(String textoAntes,int maxTam)
	{  
		StringBuffer result = new StringBuffer();
      
		try{
			System.out.print(textoAntes);
         int cont = 0;
			char tecla = (char)System.in.read();
			while((tecla != 13) && (cont < maxTam))
			{
				cont++; 	  
				result.append(tecla);
				tecla = (char)System.in.read();
			}                                                     
			for(int i = System.in.available();i > 0 ;i--)
			{         
				System.in.read();
			}
			
			while(cont<maxTam)
			{
				result.append(' ');
				cont++;
			}			
                  
		}catch(IOException ex)
		{}
		return result.toString();
	} 	
	
	public void escreveMensagem(String mensagem)
	{ 
		System.out.println(mensagem);
	}
	
	public void escreveErro(String mensagem,boolean apagaTela)
   { 
		
	   System.out.println(" ---------------------------------------------------------------------------");
	   System.out.println("| "+mensagem+"!!  Pressione ENTER para continuar");
		System.out.println(" ---------------------------------------------------------------------------");
	   leTecla("");			
   }

}
